import makeArvadosRequest from 'make-arvados-request';

function wbDownloadFile(arvHost, arvToken,
  manifestReader, path) {

  const file = manifestReader.getFile(path);
  const name = path.split('/').reverse()[0];
  const blockRefs = file[0];
  let proxy;

  let prom = makeArvadosRequest(arvHost, arvToken,
    '/arvados/v1/keep_services');
  prom = prom.then(xhr => {
    const services = xhr.response['items'];
    const proxies = services.filter(svc => (svc.service_type === 'proxy'));
    const n = Math.floor(Math.random() * proxies.length);
    proxy = proxies[n];
  });

  const blocks = [];
  for (let i = 0; i < blockRefs.length; i++) {
    const [ locator, position, size ] = blockRefs[i];

    prom = prom.then(() => makeArvadosRequest(
      proxy.service_host + ':' + proxy.service_port,
      arvToken,
      '/' + locator,
      { 'useSsl': proxy.service_ssl_flag,
        'responseType': 'arraybuffer' }
    ));

    prom = prom.then(xhr => (blocks.push(xhr.response.slice(position,
      position + size))));
  }

  prom = prom.then(() => blocks);

  /* prom = prom.then(() => {
    const blob = new Blob(blocks);
    const url = window.URL.createObjectURL(blob);
    const a = document.createElement('a');
    a.href = url;
    a.download = name;
    a.click();
  }); */

  return prom;
}

export default wbDownloadFile;
